<?php

ini_set('memory_limit', '100M');

include_once(dirname(__FILE__).'/../../includes/global.php');
include_once(dirname(__FILE__).'/../../includes/zip.lib.php');

include_once('Export.php');    
include_once('ExportOutput.php');    

//LoadCommandLineParameters();
  $System = new System();
  $System->DoNotShowPage = true;
  	$System->Run();

function SetProgres($Export,$per) {
        $File = new FileStream();
        $File->CreateFile($Export->TempDir.'progress');
        $File->WriteLine(10);
}

while(1)
{
  // DBC files
  $DbResult = $System->Database->query('SELECT `ExportTask`.`Export`, `Export`.`Id` AS `ExportId` FROM `ExportTask`'.
    ' LEFT JOIN `Export` ON `Export`.`Id` = `ExportTask`.`Export` WHERE `Export`.`OutputType` = 9 AND `ExportTask`.`TimeFinish` IS NULL');
  while($DbRow = $DbResult->fetch_assoc()) 
  {
    echo(StrFTime("%d/%m/%Y %H:%M:%S", time()).': Generování DBC souborů pro export '.$DbRow['ExportId'].'.. '."\n");
    if($DbRow['ExportId'] != '') 
    {     
      try 
      {
        $Export = new Export($System);
        $Export->Id = $DbRow['ExportId'];
        $Export->Init();

        SetProgres($Export,10);

        echo('Mazání starých souborů...'."\n");
        
        // Delete old files
        if(file_exists($Export->TempDir.'dbc/'))
        {
          $Dir = opendir($Export->TempDir.'dbc/') ;
          while(($File = readdir($Dir)) !== false) 
          {
            if(($File != '..') and ($File != '.')) unlink($Export->TempDir.'dbc/'.$File);
          }
          closedir($Dir);
        }
        if(file_exists($Export->TempDir.'CzWoW_DBC.zip')) unlink($Export->TempDir.'CzWoW_DBC.zip');

        SetProgres($Export,20);
        if(function_exists('gzcompress')) 
        {
          $Export->ExportToDBC();
          echo('Komprese...'."\n");
          exec('zip -r -j '.$Export->TempDir.'CzWoW_DBC.zip '.$Export->TempDir.'dbc/');
          echo('Hotovo'."\n");
          SetProgres($Export,80);
        } else echo('Funkce pro tvorbu Zip souboru není podporována!'."\n");
        $System->Database->query('UPDATE `ExportTask` SET `TimeFinish`=NOW() WHERE `Export`='.$Export->Id);
      } catch (Exception $e) 
      {
        echo 'Caught exception: ',  $e->getMessage(), "\n";
      }
      if (file_exists($Export->TempDir.'progress')) unlink($Export->TempDir.'progress');
    } else
    {
      $System->Database->query('DELETE FROM `ExportTask` WHERE `Export`='.$DbRow['Export']);
      echo('Export '.$DbRow['Export'].' nenalezen. Jeho úloha smazána.'."\n");
    }
  }

  //EXE files
  $DbResult = $System->Database->query('SELECT `ExportTask`.`Export`, `Export`.`Id` AS `ExportId` FROM `ExportTask`'.
    ' LEFT JOIN `Export` ON `Export`.`Id` = `ExportTask`.`Export` WHERE `Export`.`OutputType` = 10 AND `ExportTask`.`TimeFinish` IS NULL');
  while($DbRow = $DbResult->fetch_assoc()) 
  {
    echo(StrFTime("%d/%m/%Y %H:%M:%S", time()).': Generování EXE souboru pro export '.$DbRow['ExportId'].'.. '."\n");
    if($DbRow['ExportId'] != '') 
    {     
      echo shell_exec('"'.dirname(__FILE__).'./client_cz_export.sh" '.$DbRow['ExportId'].'');
      $System->Database->query('UPDATE `ExportTask` SET `TimeFinish`=NOW() WHERE `Export`='.$DbRow['Export']);
    } else
    {
      $System->Database->query('DELETE FROM `ExportTask` WHERE `Export`='.$DbRow['Export']);
      echo('Export '.$DbRow['Export'].' nenalezen. Jeho úloha smazána.'."\n");
    }
  }
  sleep($Config['ExportTaskProcessPeriod']);
}

//  WriteLog('Generování dbc úloh', LOG_TYPE_DOWNLOAD);
